#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    vector<string> odgovor;
    int N;
    int x;
    vector<int> glavni;
    cin >> N;
    for (int i = 0; i < N; i++){
        cin >> x;
        glavni.push_back(x);
    }
    int Q;
    cin >> Q;
    int li;
    int ri;
    bool moze;
    vector<int> pomocni;
    for (int i = 0; i < Q; i++){
        cin >> li >> ri;
        pomocni = vector<int>(glavni.begin() + li - 1, glavni.begin() + ri);
        if (is_sorted(pomocni.begin(), pomocni.end())){
            moze = true;
        }
        else{
            for (int j = 0; j < ri - li; j++){
                if(pomocni[j]>pomocni[j+1]){
                    if( ((is_sorted(pomocni.begin(), pomocni.begin() + j)) && (is_sorted(pomocni.begin() + j + 1, pomocni.end())) && ((pomocni[j-1] <= pomocni[j+1]) || (j-1<0))) || ((is_sorted(pomocni.begin(), pomocni.begin() + j + 1)) && (is_sorted(pomocni.begin() + j + 2, pomocni.end())) && ((pomocni[j] <= pomocni[j+2]) || (j+2>ri - li)) ) ){
                        moze = true;
                        break;
                    }
                    else{
                        moze = false;
                        break;
                    }
                }
            }
        }
        if(moze){
            odgovor.push_back("DA");
        }
        else{
            odgovor.push_back("NE");
        }
    }
    for (int i = 0; i < Q; i++){
        cout << odgovor[i];
        if (i!=Q-1){
            cout << "\n";
        }
    }
    return 0;
}